
//   Display DOGM128 mit Atxmega32A4  intern 32 MHz/2 = 16Mhz Takt

/* 	
	
	nderung fr DOGM132  3 Parameter(gleich am Anfang)dogm-graphic.h
	
	nderung fr DOGM132  in der Funktion lcd_init() dogm-graphic.c
	
	LCD_SET_BIAS_VOLTAGE(7);      3  DOGM132     7  DOGM128  
   	LCD_SET_VOLUME_MODE(0x16);    1F DOGM132     16 DOGM128	


            ATXMEGA         -->           DOGM128     	   BMP085

	- Connect PC1  A0  		(Pin12)			PIN38								
	- Connect PC2  Reset  	(Pin13)			Pin39
	- Connect PC4  CS  		(Pin14)	     	Pin40
	- Connect PC5  MOSI		(Pin15) 		PIN36
  	- Connect PC6  MISO		 --				 --
  	- Connect PC7  SCK  	(Pin17)		   	PIN37           	
		
  	- Connect PE0  SDA		(Pin28)							SDA  PIN7			
  	- Connect PE1  SCL  	(Pin29)		   	          		SCL  PIN6
  	- Connect PB0      		(Pin4)		   	          		XCLR PIN8 
  	- Connect PB2     		(Pin6)		   	          		EOC  PIN2 

	32khz Uhrenquarz TOSC1/TOSC2 PIN36/37
	delay_ms()in der avr_compiler.h definiert  

*/


#include "tools.h"


	#define SLAVE_ADDRESS    0xEE 		// BMP085 Drucksensor
	#define pow(x, y) ((long)1 << y) 	// Verschiebe-Macro
	#define RTC_CYCLES_1S     1024		// RTC Takt

	FONT_P   global_font_select;  		// wird fr xprintf bentigt
	uint8_t  global_font_style;			// wird fr xprintf bentigt
	

	typedef struct { 	// globale Daten BMP085 Drucksensor
	int16_t    	AC1;                                                               
    int16_t    	AC2; 
	int16_t    	AC3; 
	int16_t    	AC4; 
	int16_t    	AC5; 
	int16_t    	AC6; 
	int16_t    	B1; 
	int16_t    	B2; 
	int16_t    	MB; 
	int16_t    	MC; 
	int16_t    	MD; 
	int32_t    	DATA0; 
	int32_t    	DATA1; 
    int32_t    	DATA2; 
	int32_t  	UT;	// uncompensierte Temperatur Ausgabe 
	int32_t  	UP;	// uncompensierte Druck Ausgabe
	int32_t  	C_X1;
	int32_t  	C_X2;
	int32_t  	C_X3;
	int32_t  	C_B3;
	uint32_t  	C_B4;
	int32_t  	C_B5;
	int32_t  	C_B6;
	uint32_t  	C_B7;
	int32_t  	C_T; // Temperatur Ausgabe
	int32_t  	C_P; // Druck Ausgabe
	
	} BUFFER; static BUFFER bmp085;  
	
TWI_Master_t twiMaster;    /*!< ATMELXMEGA TWI master module. */




typedef struct { // fr Uhrenausgabe
	uint8_t sekunde;	
	uint8_t minute;	
 	uint8_t stunde;
	uint8_t tag;
	uint8_t monat;
	uint8_t jahr;

}  RTC_BUFFER;

static RTC_BUFFER time; 



int main (void)
{
  // 32/2=16 MHZ Takt
 //-----------------------------------------------------------------------------
  	OSC.CTRL = OSC_RC32MEN_bm | OSC_RC32KEN_bm;
   	while(!(OSC.STATUS & OSC_RC32MRDY_bm));
  	while(!(OSC.STATUS & OSC_RC32KRDY_bm));
	/* Start Calibrating the 32MHz Clock using * the internal calibrated 32kHz Oscillator */
 	OSC.DFLLCTRL = (0 << OSC_RC32MCREF_bp);
  	DFLLRC32M.CTRL = DFLL_ENABLE_bm;
   	CCP = CCP_IOREG_gc;
  	CLK.CTRL = CLK_SCLKSEL_RC32M_gc;
	CLKSYS_Prescalers_Config( CLK_PSADIV_2_gc, CLK_PSBCDIV_1_1_gc ); // 16 MHZ Takt
//-----------------------------------------------------------------------------
 	// 32khz Uhrenquarz TOSC1/TOSC2 PIN36/37
	CLKSYS_XOSC_Config( 0, false, OSC_XOSCSEL_32KHz_gc ); 
  	CLKSYS_Enable( OSC_XOSCEN_bm );        /* Does an OR with current Osc bits */ 
  	do {} while ( CLKSYS_IsReady( OSC_XOSCRDY_bm ) == 0 );  
  	CLKSYS_RTC_ClockSource_Enable( CLK_RTCSRC_TOSC_gc ); /* RTC source is 1024 Hz from 32kHz crystal oscillator on TOSC */ 
  	while( RTC_Busy() ); /* Wait for the RTC clock domain to synchronize with the CPU clock domain */ 

	/* Configure RTC period to 1 second. */
	RTC_Initialize( RTC_CYCLES_1S, 0, 0, RTC_PRESCALER_DIV1_gc );

	/* Enable overflow interrupt. */
	RTC_SetIntLevels( RTC_OVFINTLVL_LO_gc, RTC_COMPINTLVL_OFF_gc );
	
	TWI_MasterInit(&twiMaster,&TWIE,TWI_MASTER_INTLVL_HI_gc,TWI_BAUDSETTING);
	
	PORTE.DIRSET   = PIN0_bm;  		// Als Ausgang  TWI SDA
	PORTE.DIRSET   = PIN1_bm; 		// Als Ausgang  TWI SCL
	// Enable HI/MED/LO interrupt level

	sei(); 	// Interupt einschalten
	
	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	
	SPI_PORT_Init(); 	// SPI Port Init
 	SPI_Init();			// SPI Init
	lcd_init();			// DOGM Init
	delay_ms(100);  	// 100ms warten Display Init


	PORTB.DIRSET   = PIN0_bm;  		// Ausgangsport BMP085 -> reset
	PORTB.DIRCLR   = PIN2_bm;  		// Eingangsport BMP085 -> adc-wandlung abwarten

	PORTB.OUTSET   = PIN0_bm;  		// Ausgangsport BMP085 -> reset

	
	PORTB.OUTCLR  = PIN0_bm;  		// BMP085 -> reset
	delay_ms(10);
	PORTB.OUTSET  = PIN0_bm;  
	delay_ms(10);
	
	rtcInit();	 	//zum Stellen der Uhr einmal ausfhren
	
	font_set_config(FONT_FIXED_8, NORMAL); 		// fr xprintf vorbereiten
	
	xfunc_out = (void (*)(char))putc_simple; 	// Xprintf(..) mit Ausgabe (SPI DOGM132) verbinden
												// nheres in der xitoa.h

	bmp085_auslesen_EEPROM(&twiMaster); 		// EEPROM BMP085 auslesen

	
	while(true) 
	{  
	bmp085_auslesen_UT(&twiMaster); 			//Temperatur Daten holen
	bmp085_auslesen_UP(&twiMaster); 			//Druck Daten holen

	delay_s(1);		
	
	ausgabe();	
					
	
	}
return 0;
} /* end of main */


void bmp085_auslesen_EEPROM(TWI_Master_t *twi) // EEPROM BMP085 auslesen
{
		uint8_t adress_buffer[1];	
 		adress_buffer[0]=0xaa;

		
		TWI_MasterWrite(&twiMaster,SLAVE_ADDRESS,adress_buffer,1);
		
		delay_ms(10);

		
		TWI_MasterWriteRead(&twiMaster,SLAVE_ADDRESS,0,0,22);

		delay_ms(10);

		bmp085.AC1  = (twi->readData[0]  <<8) | twi->readData[1]; 	  //AC1
		bmp085.AC2  = (twi->readData[2]  <<8) | twi->readData[3]; 	  //AC2
		bmp085.AC3  = (twi->readData[4]  <<8) | twi->readData[5]; 	  //AC3
		bmp085.AC4  = (twi->readData[6]  <<8) | twi->readData[7]; 	  //AC4
		bmp085.AC5  = (twi->readData[8]  <<8) | twi->readData[9]; 	  //AC5
		bmp085.AC6  = (twi->readData[10] <<8) | twi->readData[11];   //AC6
		bmp085.B1   = (twi->readData[12] <<8) | twi->readData[13];   //B1 
		bmp085.B2   = (twi->readData[14] <<8) | twi->readData[15];   //B2 
		bmp085.MB   = (twi->readData[16] <<8) | twi->readData[17];   //MB 
		bmp085.MC   = (twi->readData[18] <<8) | twi->readData[19];   //MC 
		bmp085.MD   = (twi->readData[20] <<8) | twi->readData[21];   //MD 


}

void bmp085_auslesen_UT(TWI_Master_t *twi) // Temp unkompensiert auslesen 
{
 		uint8_t adress_buffer[1];
		uint8_t s_buffer[8];		
		
		s_buffer[0]= 0xf4; 	//Startadresse schreiben
		s_buffer[1]= 0x2e; 	//Wandlung fr Temperatur starten 
		
		while (twiMaster.status != TWIM_STATUS_READY) {
			// Wait until transaction is complete
		}

		TWI_MasterWriteRead(&twiMaster,SLAVE_ADDRESS,s_buffer,2,0);	//Wandlung fr Temperatur starten 
			
		while(!(PORTB.IN &(1<<PIN2_bp)));// Wandlung fertig

//--------auslesen Temperatur----------------
		
		
		adress_buffer[0] = 0xf6;	// Daten auslesen
		
		TWI_MasterWrite(&twiMaster,SLAVE_ADDRESS,adress_buffer,1);
	
		while (twiMaster.status != TWIM_STATUS_READY) {
			// Wait until transaction is complete. 
		}
		
		
		TWI_MasterWriteRead(&twiMaster,SLAVE_ADDRESS,0,0,2); 
		
		delay_ms(25);	// wichtig !!                    
		
		bmp085.DATA0 = twi->readData[0];
		bmp085.DATA1 = twi->readData[1];
	
		bmp085.UT = (bmp085.DATA0 << 8) + bmp085.DATA1;// F6/F7 Temp unkompensiert

// errechne Temperatur 
		bmp085.C_X1 = (bmp085.UT - bmp085.AC6) * bmp085.AC5 / pow(2, 15);
		bmp085.C_X2 =  (bmp085.MC * pow(2, 11))/(bmp085.C_X1 + bmp085.MD);
		bmp085.C_B5 =  (bmp085.C_X1 + bmp085.C_X2);
		bmp085.C_T  =  (bmp085.C_B5 + 8)/ pow(2, 4);			// Ergebnis Temperatur

		
}

void bmp085_auslesen_UP(TWI_Master_t *twi) // Druck unkompensiert auslesen 
{
  		
		int16_t oss = 0; 
		uint8_t adress_buffer[1];   // Adressbuffer
 		uint8_t s_buffer[4];	


		s_buffer[0]= 0xF4; 	//Wandlung fr Druck starten 
		s_buffer[1]= 0x34 | (oss << 6); 	
		
		while (twiMaster.status != TWIM_STATUS_READY) {
			// Wait until transaction is complete. 
		}

		TWI_MasterWriteRead(&twiMaster,SLAVE_ADDRESS,s_buffer,2,0); //Wandlung fr Druck starten 
			
		while(!(PORTB.IN &(1<<PIN2_bp)));// Wandlung fertig


//-----------------------------------------------------------------------------
		
		adress_buffer[0]=0xf6; // Daten auslesen
		TWI_MasterWrite(&twiMaster,SLAVE_ADDRESS,adress_buffer,1);
	
		while (twiMaster.status != TWIM_STATUS_READY) {
			// Wait until transaction is complete. 
		}
		
		
		
		TWI_MasterWriteRead(&twiMaster,SLAVE_ADDRESS,0,0,3); // Daten auslesen
			                    
		delay_ms(25); // wichtig !!
		
		bmp085.DATA0 = twi->readData[0];
		bmp085.DATA1 = twi->readData[1];
		bmp085.DATA2 = twi->readData[2];

		bmp085.UP = ((bmp085.DATA0 << 16) | ( bmp085.DATA1 << 8) | bmp085.DATA2) >> (8 - oss);

		
//-----------------------------------------------------------------------------
// errechne Druck 
		
		bmp085.C_B6 = bmp085.C_B5 - 4000;
		bmp085.C_X1 = (bmp085.B2 * (bmp085.C_B6 * bmp085.C_B6 / pow(2, 12))) / pow(2, 11);
		bmp085.C_X2 = bmp085.AC2 * bmp085.C_B6 / pow(2, 11);
		bmp085.C_X3 = bmp085.C_X1 + bmp085.C_X2;
		bmp085.C_B3 = ((((unsigned long)bmp085.AC1 * 4 + bmp085.C_X3) << oss) + 2) / 4;
		bmp085.C_X1 = bmp085.AC3 * bmp085.C_B6 / pow(2, 13);
		bmp085.C_X2 = (bmp085.B1 * (bmp085.C_B6 * bmp085.C_B6 / pow(2, 12))) / pow(2, 16);
		bmp085.C_X3 = ((bmp085.C_X1 + bmp085.C_X2) + 2) / pow(2, 2);
		bmp085.C_B4 = bmp085.AC4 * (unsigned long)(bmp085.C_X3 + 32768) / pow(2, 15);
		bmp085.C_B7 = ((unsigned long)bmp085.UP - bmp085.C_B3) * (50000 >> oss);
		if (bmp085.C_B7 < 0x80000000) 
		{
		 bmp085.C_P = (bmp085.C_B7 * 2) / bmp085.C_B4;
		} 
		else 
		{
		bmp085.C_P = (bmp085.C_B7 / bmp085.C_B4) * 2;
		}
		bmp085.C_X1 = (bmp085.C_P / pow(2, 8)) * (bmp085.C_P / pow(2, 8));
		bmp085.C_X1 = (bmp085.C_X1 * 3038) / pow(2, 16);
		bmp085.C_X2 = (-7357 * bmp085.C_P) / pow(2, 16);
		
		bmp085.C_P = bmp085.C_P + (bmp085.C_X1 + bmp085.C_X2 + 3791) / pow(2, 4);
		
}



//---------------------Ausgabe-Relais Display----------------------------------

void ausgabe(void) 	// Zeit und Datum ausgeben, 
{
	
		lcd_moveto_xy(0,0);	
		lcd_put_string(FONT_FIXED_8 ,NORMAL,"Temp:   "); //Temperaturanzeige
		lcd_put_num(FONT_FIXED_8 ,NORMAL,10, 4,  TRUE, ' ',(bmp085.C_T/10)); 
		lcd_put_string(FONT_FIXED_8 ,NORMAL," C "); // Diverse Zeichen , String

	
		lcd_moveto_xy(1,0);	 //Druckanzeige
		lcd_put_string(FONT_FIXED_8 ,NORMAL,"Druck: ");
		lcd_put_num(FONT_FIXED_8 ,NORMAL,10, 5,  FALSE, ' ',(bmp085.C_P + 6036)/100); // um 2 Stellen gekrzt	
		lcd_put_string(FONT_FIXED_8 ,NORMAL," hPa ");	//82140 Olching +505 Meter ber normal Null 						
														//6036=((505/10)*1,2)*100
		lcd_moveto_xy(2,0);	
		xprintf(PSTR("Uhrzeit: %02d:%02d:%02d"),time.stunde,time.minute,time.sekunde);
		
		//lcd_moveto_xy(3,0);	
		// hier wird mal die Druck-Tendenz eingefgt

}

//RTC
ISR(RTC_OVF_vect)
{
	static char __attribute__ ((progmem)) monattagTable[] = {31,28,31,30,31,30,31,31,30,31,30,31};


///----------------------
	// update real-time clock registers
		time.sekunde++;							// increment sekunde
		if(time.sekunde > 59)					// check sekunde overflow
		{
			time.sekunde -= 60;
			time.minute++;						// increment minute
			if(time.minute > 59)				// check minute overflow
			{
				time.minute -= 60;
				time.stunde++;					// increment stunde
				if(time.stunde > 23)				// check stunde overflow
				{
					time.stunde -= 24;
					time.tag++;					// increment tags
					// check tags overflow
					if(time.tag == pgm_read_byte(&monattagTable[time.monat-1]))
					{
						time.tag = 1;
						time.monat++;			// increment monats
						if(time.monat == 13)		// check monats overflow
						{
							time.monat = 1;
							time.jahr++;			// increment jahrs
						}
					}
				}
			}
		}
	
}

void rtcInit(void) //zum Stellen der Uhr- einmal ausfhren
{
	time.sekunde = 0;
	time.minute = 05;
	time.stunde = 13;
	time.tag = 9;
	time.monat = 3;
	time.jahr = 10;
	}


void font_set_config(FONT_P font, uint8_t style){ //wird fr xprintf(PSTR( )) bentigt
  
  global_font_select = font;
  global_font_style = style;

}


uint16_t putc_simple(char c) {   //wird fr xprintf(PSTR( )) bentigt

return lcd_put_char(global_font_select,global_font_style,c);

}
 


ISR(TWIE_TWIM_vect) // TWI BMP085
{
	TWI_MasterInterruptHandler(&twiMaster);
}



