
//   Display DOGM128 mit Atxmega32A4  intern 32 MHz/2 = 16Mhz Takt

/* 	
	
	nderung fr DOGM132  3 Parameter(gleich am Anfang)dogm-graphic.h
	
	nderung fr DOGM132  in der Funktion lcd_init() dogm-graphic.c
	
	LCD_SET_BIAS_VOLTAGE(7);      3  DOGM132     7  DOGM128  
   	LCD_SET_VOLUME_MODE(0x16);    1F DOGM132     16 DOGM128	


            ATXMEGA         -->           DOGM128     	   BMP085

	- Connect PC1  A0  		(Pin12)			PIN38								
	- Connect PC2  Reset  	(Pin13)			Pin39
	- Connect PC4  CS  		(Pin14)	     	Pin40
	- Connect PC5  MOSI		(Pin15) 		PIN36
  	- Connect PC6  MISO		 --				 --
  	- Connect PC7  SCK  	(Pin17)		   	PIN37           	
		
  	- Connect PE0  SDA		(Pin28)							SDA  PIN7			
  	- Connect PE1  SCL  	(Pin29)		   	          		SCL  PIN6
  	- Connect PB0      		(Pin4)		   	          		XCLR PIN8 
  	- Connect PB2     		(Pin6)		   	          		EOC  PIN2 

	32khz Uhrenquarz TOSC1/TOSC2 PIN36/37
	delay_ms()in der avr_compiler.h definiert  

*/


#include "tools.h"


	FONT_P   global_font_select;  		// wird fr xprintf bentigt
	uint8_t  global_font_style;			// wird fr xprintf bentigt
                               

int main (void)
{
  // 32/2=16 MHZ Takt
 //-----------------------------------------------------------------------------
  	OSC.CTRL = OSC_RC32MEN_bm | OSC_RC32KEN_bm;
   	while(!(OSC.STATUS & OSC_RC32MRDY_bm));
  	while(!(OSC.STATUS & OSC_RC32KRDY_bm));
	/* Start Calibrating the 32MHz Clock using * the internal calibrated 32kHz Oscillator */
 	OSC.DFLLCTRL = (0 << OSC_RC32MCREF_bp);
  	DFLLRC32M.CTRL = DFLL_ENABLE_bm;
   	CCP = CCP_IOREG_gc;
  	CLK.CTRL = CLK_SCLKSEL_RC32M_gc;
	CLKSYS_Prescalers_Config( CLK_PSADIV_2_gc, CLK_PSBCDIV_1_1_gc ); // 16 MHZ Takt
//-----------------------------------------------------------------------------

	sei(); 	// Interupt einschalten
	
	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	
	SPI_PORT_Init(); 	// SPI Port Init
 	SPI_Init();			// SPI Init
	lcd_init();			// DOGM Init
	delay_ms(100);  	// 100ms warten Display Init

	font_set_config(FONT_FIXED_8, NORMAL); 		// fr xprintf vorbereiten
	xfunc_out = (void (*)(char))putc_simple; 	// Xprintf(..) mit Ausgabe (SPI DOGM132) verbinden

//------------------------Test-------------------------------------------------
	uint8_t zahl=100;
	char text[]="siehe xitoa.h";

	font_set_config(FONT_FIXED_8, NORMAL); 		// fr xprintf vorbereiten
	
	xfunc_out = (void (*)(char))putc_simple; 	// Xprintf(..) mit Ausgabe (SPI DOGM132) verbinden
												// nheres in der xitoa.h
	lcd_moveto_xy(0,0);	
	lcd_put_string(FONT_PROP_8 ,NORMAL,"alles ok"); //Temperaturanzeige

	lcd_moveto_xy(1,0);	
	xprintf(PSTR("Zahl= %03d"),zahl); //Dezimalausgabe mit Lnge
	
	lcd_moveto_xy(2,0);	
	xprintf(PSTR("Zahl in Hex = %X"),zahl); //Temperaturanzeige


	lcd_moveto_xy(3,0);	
	xprintf(PSTR("%s"),&text[0]); //Temperaturanzeige

//-----------------------------------------------------------------------------	

while(true) 
	{  

	delay_s(1);		
			
	
	}
return 0;
} /* end of main */




void font_set_config(FONT_P font, uint8_t style){ //wird fr xprintf(PSTR( )) bentigt
  
  global_font_select = font;
  global_font_style = style;

}


uint16_t putc_simple(char c) {   //wird fr xprintf(PSTR( )) bentigt

return lcd_put_char(global_font_select,global_font_style,c);

}
 



